/*
 * Copyright (c), All right reserved
 * Gazing Design - http://www.NoGray.com
 * Free to use as long as the copyrights
 * notice is not removed. For customization
 * or installation service, please contact
 * us at http://www.nogray.com/contact.php
 */
 
(function($){
	$(function(){
		// the message you want to alert the user before they leave the page
		var leaving_message = 'We Can Help! Click "Stay on This Page" and we can help you find what you are looking for.';
		
		// how many pages the user should visit so they are not considered "Bounced Visits"
		// a bounced visit is when the user come to your site and leaves right away
		// you should keep this number low to avoid annoying users
		var bounced_visits = 1000;
		
		// how many hours before from the initial pop up should the user see
		// the pop up again. This will avoid showing the user the same message
		// if they visit the site and bounced in the same day
		var next_pop_delay = 24; // 24 hours 
		
		// do not change anything below this line unless you know what you are doing
		
		// checking if the user is over the bounce visit
		var num_pgs = parseInt(readCookie('scndchnce_pgct'), 0);
		if (isNaN(num_pgs)) num_pgs = 0;
		
		if (num_pgs > bounced_visits) return;
		
		num_pgs++;
		createCookie('scndchnce_pgct', num_pgs, next_pop_delay);
		
		var mouse_enter = mouse_leave = 0;
		
		// creating the tracking divs on top of the page
		var dv1 = document.createElement('div');
		dv1.className = 'second-chance-bar-1';
		dv1.innerHTML = '&nbsp;';
		
		$(dv1).mouseenter(function(evt){
			mouse_leave = evt.clientY;
		});
		
		var dv2 = document.createElement('div');
		dv2.className = 'second-chance-bar-2';
		dv2.innerHTML = '&nbsp;';
		
		$(dv2).mouseenter(function(evt){
			mouse_enter = evt.clientY;
		});
		
		// appending the tracking divs to the body
		document.body.appendChild(dv1);
		document.body.appendChild(dv2);
		
		// clicking on the overlay background will remove the overlay
		$('#second_chance_overlay').click(function(){
			$('#second_chance_overlay').removeClass('second-chance-overlay-active');
			$('#second_chance_form').removeClass('second-chance-form-active');
		});
		
		// perventing the overlay from closing when clicking on the content
		$('#second_chance_form').click(function(evt){
			evt.stopPropagation();
		});
		
		// closing the overlay when clicking on the close button
		$('#second_form_close').click(function(evt){
			$('#second_chance_overlay').click();
		});
		
		// make sure the alert is not generated from a link
		// or button click
		var stop_body_click = false;
		$(document.body).click(function(evt){
			var elm = evt.target.tagName.toLowerCase();
			if ((elm == 'a') || (elm == 'input')) {
				stop_body_click = true;
			}
		});
		
		// adding the unload event to alert the user that you can help them
		window.onbeforeunload = function(){
			if (stop_body_click) return;
			
			if (mouse_enter == 0) return;
			// if the user moved the mouse out of the page (e.g. to the back button)
			// ask them to wait and see if they need more help
			if ((mouse_leave > 0) && (mouse_enter > mouse_leave)) {
				$('#second_chance_overlay').addClass('second-chance-overlay-active');
				$('#second_chance_form').css({
					marginTop: document.getElementById('second_chance_form').scrollHeight/2 * -1,
					marginLeft:	$('#second_chance_form').width()/2 * -1
				});
				
				setTimeout(function(){
					$('#second_chance_form').addClass('second-chance-form-active');
				}, 100);
				
				mouse_enter = mouse_leave = 0;
				
				return leaving_message;
			}
			
		};
		
		// cookies functions
		function createCookie(name,value,hours) {
			if (hours) {
				var date = new Date();
				date.setTime(date.getTime()+(hours*60*60*1000));
				var expires = "; expires="+date.toGMTString();
			}
			else var expires = "";
			document.cookie = name+"="+value+expires+"; path=/";
		}
		
		function readCookie(name) {
			var nameEQ = name + "=";
			var ca = document.cookie.split(';');
			for(var i=0;i < ca.length;i++) {
				var c = ca[i];
				while (c.charAt(0)==' ') c = c.substring(1,c.length);
				if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length,c.length);
			}
			return null;
		}
	});
})(jQuery);